static char* g_tipmsg_id = "@(#) $Id: tipmsg.c,v 1.10 2000/08/07 04:57:15 kouno Exp $";

/* 
 *  Project: IPMSG
 *  Author & Copyright:  KOHNO TAKASHI(δ) <kouno@catnet.ne.jp>
 *  Mail: kouno@catnet.ne.jp
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <limits.h>		   
#include <netdb.h>
#include <signal.h>
#include <pwd.h>
#include <errno.h>
#include <time.h>
#include <fcntl.h>
#include <ctype.h>
#include <sys/wait.h>
#include <sys/mman.h>
#include <sys/time.h>
#include <sys/stat.h>
#include <sys/param.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>

#include "protocol.h"
#include "tipmsg.h"

#if defined(DEBUG)
#define line	fprintf(stderr, "Line %d\n", __LINE__);fflush(stderr);fflush(stdout)
#define d_printf printf
#else
#define debug
#define d_printf dummy_function
#endif

/* ѿ  */
static int g_exit = 0;
/* ѿ ޤ */

int main(int argc, char *argv[])
{
	NET_MNG net_mng;
	CONFIG_MNG config_mng;
	USERLIST_MNG userlist_mng = {NULL, NULL};
	MSGPACKAGE_MNG msgpackage_mng = {NULL, NULL, NULL, 0};

	NET_MNG* net = &net_mng;
	CONFIG_MNG* cfg = &config_mng;
	USERLIST_MNG* ulm = &userlist_mng;
	MSGPACKAGE_MNG* mpm =  &msgpackage_mng;

    int ret = 0, flag=1, pos;
	struct sockaddr_in	saddr;
	memset(net, 0, sizeof(NET_MNG));
	memset(cfg, 0, sizeof(CONFIG_MNG));

	/* Ԥʤ */
	if (!(pos = configuration(argc, argv, cfg))){
		return 1;
	}
	net->append = cfg->append;
	mpm->max_store_message = cfg->store_message;

	/* Tearminate */
	if (cfg->special_mode & SPECIAL_TERM_MODE){
		int pid;
		if (!(pid = read_pid_file(cfg->pid_file))) goto END;
		if (kill(pid, SIGTERM) == -1){
			fprintf(stderr, "Can't kill process(%d) : %s\n", 
					pid, strerror(errno));
			ret = errno;
		} else {
			printf("Tearminate...\n");
			ret = 0;
		} 
		goto END;
	}

	/* ǡ⡼ɤ */
	if (cfg->daemon && !cfg->special_mode){
		became_a_daemon(argv);
	}

	/* ǥ쥯ȥ */
	mkdir(cfg->tipmsgdir, 0700);
	mkdir(cfg->paper_log_dir, 0700);
	

	/* Ժ߾֤򥳥ޥɤȿ */
	if (cfg->absence.mode){
		net->append.ret |= IPMSG_ABSENCEOPT;
	} else {
		net->append.ret &= ~IPMSG_ABSENCEOPT;
	}

	/* 桼̾ */
	if (!cfg->nickname[0]){
        strcpy(cfg->nickname, getpwuid(getuid())->pw_name);
    }
	
	/* UDP åȤν */
	if ((net->sd = socket(AF_INET, SOCK_DGRAM, 0)) == -1){
		perror("Can't create UDP socket\n");
		return 1;
	}
	d_printf("SD is %d\n", net->sd);
    flag = 1;
    if (setsockopt(net->sd, SOL_SOCKET, SO_BROADCAST, (char*)&flag, sizeof(int)) == -1) {
        perror("setsockopt fail(SO_BROADCAST)");
    }

	/* sockaddr_in¤Τ */
	memset((char *)&saddr, 0, sizeof(saddr));
	saddr.sin_family		= AF_INET;
	saddr.sin_addr.s_addr	= htonl(INADDR_ANY);
	if (cfg->special_mode & SPECIAL_SEND_MODE){
		saddr.sin_port			= htons(INADDR_ANY);
	} else {
		saddr.sin_port			= htons(cfg->ipmsg_port);
	}
	/* UDP åȥХ */
	if (bind(net->sd, (struct sockaddr *)&saddr, sizeof(saddr)) == -1){
		fprintf(stderr, "UDP Bind error %d port : %s\n", 
				cfg->ipmsg_port, ERRMSG);
		goto END;
	}

	/* send mode */
	if (cfg->special_mode & SPECIAL_SEND_MODE){
		d_printf("SPECIAL_SEND_MODE\n");
		if (access(cfg->pid_file, F_OK) != 0){
			fprintf(stderr, "Server not found, because no pid file(%s)\n",
				   cfg->pid_file);
			return 1;
		}
		if (cfg->special_mode & SPECIAL_OPT_READMSG){
			char buf[0x10];
			d_printf("SPECIAL_OPT_READMSG\n");
			sprintf(buf, "%d", cfg->readmsg_no);
			proxy_sender(NULL, 0, buf, IPMSG_READMSG, net, cfg, ulm);
		} else {
			send_message(net, cfg, ulm, argv + pos);
		}
		goto END;
	}

    /* SIGNAL */
	set_signal(interrupt_exit);

	/* Ԥ */
	create_pid_file(cfg->pid_file);
	d_printf("Create pid file : %s(%d)\n", cfg->pid_file, getpid());
	if (!recver(net, cfg, ulm, mpm)){
		ret = 1;
	}
	unlink(cfg->pid_file);

 	/* λ */
	information_for_everybody(NULL, 0, IPMSG_BR_EXIT, net, cfg, ulm);
  END:
	destroy_userlist(ulm);
 	close(net->sd);
	return ret;
}

/* Ԥʤ */
int configuration(int argc, char** argv, CONFIG_MNG* cfg)
{
	int pos;

	/* ǥե */
	default_config(cfg);

	/* ե뤬ꤵƤ̾ */
	if (!(pos = analyze_option(argc, argv, cfg))) return FALSE;
	/* ե */
	if (!cfg->filename[0] && cfg->ipmsg_port != IPMSG_PORT){
		sprintf(cfg->filename, "%s/%s.%d", 
				cfg->tipmsgdir, CONFIG_FILE, cfg->ipmsg_port);
		if (access(cfg->filename, R_OK) != 0) cfg->filename[0] = '\0';
	}
	if (!cfg->filename[0]){
		sprintf(cfg->filename, "%s/%s", cfg->tipmsgdir, CONFIG_FILE);
	}
	d_printf("Config file is %s\n", cfg->filename);
	/* ե뤫ɤ߹ */
    if (!load_config(cfg->filename, cfg)){
    /*	return 1; */
	}
	/* ưץβ */
	if (!analyze_option(argc, argv, cfg)){
		return FALSE;
	}
	/* ν */
	if (!proceed_config(cfg)){
		return FALSE;
	}
	return pos;
}

/* ޥɥ饤β */
int analyze_option(int argc, char** argv, CONFIG_MNG* cfg)
{
    char* endp;
	int opt, i, lp;
	char* options = "PCTefopr"; /* Need argument */
#if(0)
	char* options_all = "ABCDEHJKLNOPQSTUXefhkoprstux";
#endif
	static int reanalyze = FALSE;
	char* Xoptarg;

    /* β */
	for (lp=1; lp<argc; lp++){
		if (argv[lp][0] != '-') {
			d_printf("Unknown option(%s).\n", argv[lp]);
			break;
		}
		opt = argv[lp][1];
		if (argv[lp][2] == '\0'){
			if (lp+1 >= argc || *(Xoptarg = argv[lp+1]) == '-') Xoptarg = "";
			else if (strchr(options, opt)) lp++;
		} else {
			Xoptarg = argv[lp] + 2;
		}

		if (!*Xoptarg) d_printf("Designate option [%c]\n", (char)opt);
		else d_printf("Designate option [%c:%s]\n", (char)opt, Xoptarg);

		/* ե롦ѥݡȤλϿĴ٤ */
		if (!reanalyze){
			if (opt == 'C'){
				if (reanalyze) break;
				if (access(Xoptarg, R_OK) == 0){
					strcpy(cfg->filename, Xoptarg);
				} else {
					fprintf(stderr, "Invalid config file(%s) : %s\n",
							Xoptarg, ERRMSG);
					return 0;
				}
				d_printf("Designate config(%s).\n", cfg->filename);
				break;
			} else if (toupper(opt) == 'P'){
				/* ݡֹλ */
				if ((i = strtol(Xoptarg, &endp, 0)) != 0){
					cfg->ipmsg_port = i;
				}
				d_printf("Designate port[%d].\n", i);
			}
			continue;
		}

		/* ̾索ץ */
		switch (opt){
		case 'W':
			/* userlist ⡼ȿž */
			if (!cfg->userlist_logging){
				d_printf("Userlist loging.\n");
				cfg->userlist_logging = TRUE;
			} else {
				d_printf("Userlist no loging.\n");
				cfg->userlist_logging = FALSE;
			}
			break;
		case 'A':
			/* α⡼ɤȿž */
			if (!cfg->absence.mode){
				d_printf("I'm absence.\n");
				cfg->absence.mode = TRUE;
			} else {
				d_printf("I'm exist.\n");
				cfg->absence.mode = FALSE;
			}
			break;
		case 'Q':
			/* Entry, Exitɽȿž */
			if (!cfg->print_entry){
				d_printf("Printable Entry & Exit.\n");
				cfg->print_entry = TRUE;
			} else {
				d_printf("No Printable Entry & Exit.\n");
				cfg->print_entry = FALSE;
			}
			break;
		case 'O':
			/* ¨Υ⡼ɤȿž */
			if (!cfg->send_readmsg_on_the_receive){
				d_printf("I send readmsg on the receive message.\n");
				cfg->send_readmsg_on_the_receive = TRUE;
			} else {
				d_printf("I send readmsg on the request.\n");
				cfg->send_readmsg_on_the_receive = FALSE;
			}
			break;
		case 'P':
		case 'p':
			/* ݡֹλ */
			if ((i = strtol(Xoptarg, &endp, 0)) != 0){
				cfg->ipmsg_port = i;
			}
			d_printf("Designate port[%d].\n", i);
			break;
		case 'L':
			/* åɽ⡼ɤȿž */
			if (!cfg->live){
				d_printf("Live mode\n");
				cfg->live = TRUE;
			} else {
				d_printf("Silent mode\n");
				cfg->live = FALSE;
			}
			break;
		case 'D':
			/* ǡ⡼ɤȿž */
			if (!cfg->daemon){
				d_printf("Call daemon.\n");
				cfg->daemon = TRUE;
			} else {
				d_printf("Daemon free.\n");
				cfg->daemon = FALSE;
			}
			break;
		case 'U':
			/* 桼ꥹ⡼ɤȿž */
			if (!cfg->flush_userlist){
				d_printf("Create userlist.\n");
				cfg->flush_userlist = TRUE;
			} else {
				d_printf("No use userlist.\n");
				cfg->flush_userlist = FALSE;
			}
			break;
		case 'N':
			/* 󥨥ȥ⡼ɤȿž */
			if (!cfg->no_entry){
				d_printf("Hide ....\n");
				cfg->no_entry = TRUE;
				cfg->append.send |= IPMSG_NOADDLISTOPT;
			} else {
				d_printf("Look me!\n");
				cfg->no_entry = FALSE;
				cfg->append.send &= ~IPMSG_NOADDLISTOPT;
			}
			break;
		case 'S':
			/* SJIS ⡼ɤλ */
			Xstrncpy(cfg->char_code, CODE_SJIS, NAMELEN);
			d_printf("Kanji code is %s\n", cfg->char_code);
			break;
		case 'E':
			/* EUCJP ⡼ɤλ */
			Xstrncpy(cfg->char_code, CODE_EUCJP, NAMELEN);
			d_printf("Kanji code is %s\n", cfg->char_code);
			break;
		case 'J':
			/* JIS ⡼ɤλ */
			Xstrncpy(cfg->char_code, CODE_JIS, NAMELEN);
			d_printf("Kanji code is %s\n", cfg->char_code);
			break;
		case 'B':
			/* ʸ̤λ */
			Xstrncpy(cfg->char_code, "", NAMELEN);
			d_printf("Bare Kanji code is no transfer.\n");
			break;
		case 'K':
		case 'k':
			/* ѥȿž */
			if (cfg->append.send & IPMSG_PASSWORDOPT) {
				d_printf("Disable password opt.\n");
				cfg->append.send &= ~IPMSG_PASSWORDOPT;
			} else {
				d_printf("Enable password opt.\n");
				cfg->append.send |= IPMSG_PASSWORDOPT;
				cfg->append.send &= ~IPMSG_SECRETOPT;
			}
		case 'X':
		case 'x':
			/* ȿž */
			if (cfg->append.send & IPMSG_SECRETOPT){
				d_printf("Disable secret opt.\n");
				cfg->append.send &= ~IPMSG_SECRETOPT;
			} else {
				d_printf("Enable secret opt.\n");
				cfg->append.send |= IPMSG_SECRETOPT;
			}
			break;
		case 'H':
		case 'h':
			/* إ */
			print_usage();
			exit(0);
		case 'T':
			i = strtol(Xoptarg, &endp, 0);
			if (i >= NORMAL_USERLIST && i < NUM_OF_USERLIST){
				cfg->type_of_userlist = i;
			}
			d_printf("Designate type of userlist[%d].\n", i);
			break;
		case 'e':
			/* ǥλ */
			Xstrncpy(cfg->editor, Xoptarg, PATH_MAX);
			d_printf("Designate editor is %s.\n", cfg->editor);
			break;
		case 's':
			/* ⡼ɤλ */
			d_printf("Send mode\n");
			cfg->special_mode |= SPECIAL_SEND_MODE;
			break;
		case 'u':
			/* 桼 */
			d_printf("Use username\n");
			cfg->special_mode |= SPECIAL_SEND_MODE|SPECIAL_OPT_USE_USERNAME;
			break;
		case 't':
			/* λ */
			d_printf("Operate terminate\n");
			cfg->special_mode |= SPECIAL_TERM_MODE;
			break;
		case 'r':
			/* ֿ⡼ */
			d_printf("Reply mode\n");
			cfg->special_mode |= SPECIAL_SEND_MODE|SPECIAL_OPT_REPLY;
			cfg->reply = 0;
			if (Xoptarg[0]){
				cfg->reply = strtol(Xoptarg, &endp, 0);
				if (Xoptarg == endp) lp--;
			}
			break;
		case 'f':
			/* ե */
			cfg->special_mode |= SPECIAL_SEND_MODE;
			cfg->send_file_keep_it = TRUE;
			Xstrncpy(cfg->send_file, Xoptarg, PATH_MAX);
			d_printf("Designate sendfile : %s\n", cfg->send_file);
			break;
		case 'o':
			/* å⡼ */
			d_printf("Send [READMSG] mode\n");
			cfg->special_mode |= SPECIAL_SEND_MODE|SPECIAL_OPT_READMSG;
			if (Xoptarg[0]){
				cfg->readmsg_no = strtol(Xoptarg, &endp, 0);
				if (Xoptarg == endp) lp--;
			} else {
				cfg->readmsg_no = 0;
			}
			d_printf("READMSG[%d]\n", cfg->readmsg_no);
			break;
		case 'n':
			cfg->append.send |= IPMSG_NOADDLISTOPT | IPMSG_NOLOGOPT;
			d_printf("IPMSG_NOADDLISTOPT | IPMSG_NOLOGOPT\n");
			break;
		default:
			break;
		}
	}

	reanalyze = TRUE;
	d_printf("Analyze Done(%d)\n", lp);
	return lp;
}

/*
 * ǥեȤνܤ
 */
int default_config(CONFIG_MNG* cfg)
{
	cfg->live = TRUE;
	cfg->daemon = FALSE;
	cfg->flush_userlist = FALSE;
	cfg->no_entry = FALSE;
	cfg->print_entry = FALSE;
	cfg->ipmsg_port = IPMSG_PORT;
	cfg->store_message = DEFAULT_STORE_MESSAGE;
	cfg->hw_kana = 1;
	cfg->flush_userlist = 1;
	cfg->type_of_userlist = NORMAL_USERLIST;

	cfg->absence.mode = FALSE;

	/* ƥǥ쥯ȥ */
#if defined(TIPMSGDIR)
	strcpy(cfg->tipmsgdir, TIPMSGDIR_PATH);
#else
	sprintf(cfg->tipmsgdir, "%s/%s", getenv(ENV_HOME), TIPMSGDIR_PATH);
#endif
	/* ֥ɥ㥹 */
	cfg->broadcast.num =1;	
	cfg->broadcast.addr[0] = strdup(BROADCAST);

	/* ץ饤 */
	cfg->reply_ignore = 6;

	/* 桼ꥹȥ */
	cfg->userlist_logging = FALSE;
	return TRUE;
}

/* ǥ쥯ȥݡֹղե̾κ */
int create_filename_for_anyport(char* buf, char* def, CONFIG_MNG* cfg)
{
	char tmp[0x400];
	if (buf[0] != '/'){
		if (!buf[0]){
			if (cfg->ipmsg_port == IPMSG_PORT){
				sprintf(buf, "%s/%s", cfg->tipmsgdir, def);
			} else {
				sprintf(buf, "%s/%s.%d", 
						cfg->tipmsgdir, def, cfg->ipmsg_port);
			}
		} else {
			Xstrncpy(tmp, buf, 0x400);
			sprintf(buf, "%s/%s",  cfg->tipmsgdir, tmp);
		} 
	}
	return 1;
}

/* ̤ܤκ */
int proceed_config(CONFIG_MNG* cfg)
{
	char *ostype, *hosttype, *p;

	/* ۥ̾ȥ桼̾ */
	if (!cfg->hostname[0]){
		if (gethostname(cfg->hostname, NAMELEN) != -1){
			if ((p = strchr(cfg->hostname, '.')) != NULL) *p = '\0';
		} else {
			strcpy(cfg->hostname,"Unknown host");
		}
	}
	if (!cfg->username[0]){
		struct passwd* pw;
		char* username;
		if ((username = getenv("TIPMSG_USERNAME"))){
			strcpy(cfg->username, username);
		} else if ((pw = getpwuid(getuid()))){
			strcpy(cfg->username, pw->pw_name);
		} else {
			strcpy(cfg->username, "Unknown user");
		}
	}
	/* ̤Υ */
	create_filename_for_anyport(cfg->paper_log_dir, DEFAULT_PAPER_DIR, cfg);
	/* (Ϣ³) */
	create_filename_for_anyport(cfg->scroll_log_file, DEFAULT_SCROLL_FILE, cfg);

	/* 桼ꥹ */
	create_filename_for_anyport(cfg->userlist_file, DEFAULT_USERLIST, cfg);

	/* 桼ꥹ */
	create_filename_for_anyport(cfg->userlist_logfile, DEFAULT_USERLIST_LOG, cfg);

	/* ˥å͡ȥ롼̾ */
	if (!cfg->nickname[0])
		strcpy(cfg->nickname, cfg->username);

	/* С */
	hosttype=getenv(ENV_HOSTTYPE);
	ostype=getenv(ENV_OSTYPE);

	if (!cfg->vermsg[0]){
		sprintf(cfg->vermsg, "Text IP Messenger %s for %s %s\n\n\nBuild %s", 
				TIPMSG_VERSION,  hosttype ? hosttype : "Unknown Host", 
				ostype ? ostype : "Unknown OS", g_tipmsg_id);
	}

	/* Ժ߾ */
	create_filename_for_anyport(cfg->absence.file, DEFAULT_ABSENCEFILE, cfg);


	/* PID ե̾ */
	create_filename_for_anyport(cfg->pid_file, DEFAULT_PIDFILE, cfg);

	/* server */
	if (!cfg->server[0]){
		Xstrncpy(cfg->server, "127.0.0.1", NAMELEN);
	}
	/* code */
	if (!cfg->char_code[0]){
		Xstrncpy(cfg->char_code, CODE_SJIS, NAMELEN);
	}
	if (!cfg->char_code_in[0]){
		Xstrncpy(cfg->char_code_in, CODE_SJIS, NAMELEN);
	}
	/* send file */
	create_filename_for_anyport(cfg->send_file, DEFAULT_SENDFILE, cfg);
	if (!cfg->reply_prefix[0]){
		Xstrncpy(cfg->reply_prefix, DEFAULT_REPLY_PREFIX, NAMELEN);
	}

	return TRUE;
}

/* ե뤫ͤ */
char** make_value(char** key)
{
	int lp;
	char* p;
	char** value = NULL;
	for (lp=0; key[lp]; lp++);
	if (!(value = (char**)calloc(sizeof(char*), lp+1))){
		fprintf(stderr, "Can't allocate memory.\n");
		goto ERR;
	}

	for (lp=0; key[lp]; lp++){
		/* Ȥκ */
		if ((p = strchr(key[lp], '#'))) *p = '\0';
		if ((p = strchr(key[lp], '['))) *p = '\0';
		if (*key[lp] == '\0') continue;

		/* `='򶭤 key(), value()ʬ */
		if (!(value[lp] = strchr(key[lp],'='))){
			continue;
		}
		*value[lp] = '\0';

		/* ɬפʶκ(key) */
		for (p = key[lp] ; isspace((int)*p); p++);
		key[lp] = p;
		for (p = value[lp]-1; isspace((int)*p) && p > key[lp]; p--) *p = '\0';
		/* ɬפʶκ(value) */
		for (p = value[lp]+1; isspace((int)*p); p++);
		if (*p)	{
			value[lp] = p;
		} else {
			value[lp] = NULL;
			continue;
		}
		for (p = value[lp] ; *p; p++);
		for (p--; isspace((int)*p) && p > value[lp]; p--) *p = '\0';
	}
	return value;
  ERR:
	free(value);
	perror("Fail in make_value");
	return 0;
}

/* եʬ䤷ƥ˳Ǽ */
char** make_key(char* file)
{
	int lines, fd, pos, size, unit = 1024;
	char* buf = NULL;
	char** key = NULL;
	struct stat sbuf;
	/* եɤ߹ */
	if ((fd = open(file, O_RDONLY)) == -1) {
		fprintf(stderr, "Can't open file : %s\n", file);
		goto ERR;
	}
	if (fstat(fd, &sbuf) == -1 || sbuf.st_size == 0) {
		fprintf(stderr, "Can't stat or zero byte file : %s\n", file);
		goto ERR;
	}
	free(buf);
	if (!(buf = (char*)malloc(sbuf.st_size +1))) {
		fprintf(stderr, "Can't allocate memory.\n");
		goto ERR;
	}
	if (read(fd, buf, sbuf.st_size) < sbuf.st_size){
		fprintf(stderr, "Imcomplete, read data from %s\n", file);
		goto ERR;
	}
	close(fd);
	fd = -1;
	buf[sbuf.st_size] = '\0';

	/* ʬ */
	size = unit;
	lines = 0;
	free(key);
	if (!(key = (char**)malloc(sizeof(char*) * unit))){
		fprintf(stderr, "Can't allocate memory.\n");
		goto ERR;
	}
	key[lines++] = buf;

	for (pos = 0; pos < sbuf.st_size; pos++){
 		if (lines +1 >= size){
			char **tmp;
			size += unit;
			if (!(tmp = (char**)realloc(key, sizeof(char*) * size))){
				fprintf(stderr, "Can't reallocate memory.\n");
				goto ERR;
			}
			key = tmp;
		}
		if (buf[pos] == '\\'){
			pos++;
			continue;
		}
		if (buf[pos] == '\n'){
			buf[pos] = '\0';
			key[lines++] = buf + pos + 1;
		}
	}
	key[lines] = NULL;
	return key;

  ERR:
	perror("Fail in make_key");
	free(key);
	free(buf);buf = NULL;
	if (fd != -1) close(fd);
	return 0;
}

/* ե뤫Ƥ */
int load_config(char* fname, CONFIG_MNG* cfg)
{
	char** key;
	char** value;
	int lp, i;
	char* endp;

	if (!(key = make_key(fname))){
		return FALSE;
	}
	if (!(value = make_value(key))){
		free(key);
		return FALSE;
	}
	for (lp=0; key[lp]; lp++){
		if (!value[lp]) continue;
		/* 
		   NETWORK 
		*/
		if (strcasecmp(key[lp], "broadcast") == 0){
			char* buf;
			char* p;
			int num = cfg->broadcast.num;
			if (!(buf = strdup(value[lp]))) continue;
			for (p = strtok(buf, " ,"); p; p = strtok(NULL, " ,")){
				if (!(cfg->broadcast.addr[num++] = strdup(p))) break;
				if (num >= BROADCAST_MAX){
					d_printf("Too many broadcast address.\n");
					break;
				}
			}
			cfg->broadcast.num = num;
			free(buf);
		} else if (strcasecmp(key[lp], "server") == 0) {
			Xstrncpy(cfg->server, value[lp], NAMELEN);
		} else if (strcasecmp(key[lp], "port") == 0) {
			if ((i = strtol(value[lp], &endp, 0)) != 0) cfg->ipmsg_port = i;
		} 
		/* 
		   USER INFORMATION 
		*/
		else if (strcasecmp(key[lp], "name") == 0) {
			Xstrncpy(cfg->nickname, value[lp], NAMELEN);
		} else if (strcasecmp(key[lp], "hostname") == 0) {
			Xstrncpy(cfg->hostname, value[lp], NAMELEN);
		} else if (strcasecmp(key[lp], "group") == 0) {
			Xstrncpy(cfg->groupname, value[lp], NAMELEN);
		}	
		/* 
		   FILE 
		*/
		else if (strcasecmp(key[lp], "system dir") == 0) {
			if (*value[lp] == '~' && *(value[lp]+1) == '/'){
				sprintf(cfg->tipmsgdir, "%s%s", getenv(ENV_HOME), value[lp]+1);
			} else {
				Xstrncpy(cfg->tipmsgdir, value[lp], PATH_MAX);
			}
		} else if (strcasecmp(key[lp], "absence file") == 0) {
			Xstrncpy(cfg->absence.file, value[lp], PATH_MAX);
		}
		else if (strcasecmp(key[lp], "read check") == 0){
			if (strcasecmp(value[lp], "yes") == 0){
				cfg->append.send |= IPMSG_READCHECKOPT;
			} else {
				cfg->append.send &= ~IPMSG_READCHECKOPT;
			}
		} else if (strcasecmp(key[lp], "secret") == 0){
			if (strcasecmp(value[lp], "yes") == 0){
				cfg->append.send |= IPMSG_SECRETOPT;
			} else {
				cfg->append.send &= ~IPMSG_SECRETOPT;
			}
		} else if (strcasecmp(key[lp], "editor") == 0) {
			Xstrncpy(cfg->editor, value[lp], PATH_MAX);
		} else if (strcasecmp(key[lp], "send file") == 0) {
			if (*value[lp] == '~' && *(value[lp]+1) == '/'){
				sprintf(cfg->send_file, "%s%s", getenv(ENV_HOME), value[lp]+1);
			} else {
				Xstrncpy(cfg->send_file, value[lp], PATH_MAX);
			}
		}
		/* REPLY */
		else if (strcasecmp(key[lp], "reply ignore") == 0){
			if ((i = strtol(value[lp], &endp, 0)) != 0) cfg->reply_ignore = i;
		} else if (strcasecmp(key[lp], "reply prefix") == 0){
				Xstrncpy(cfg->reply_prefix, value[lp], NAMELEN);
		}
	    /* 
		   GENERAL
		*/
		else if (strcasecmp(key[lp], "enable special strings") == 0) {
			if (strcasecmp(value[lp], "yes") == 0){
				cfg->enable_special_strings = TRUE;
			} else {
				cfg->enable_special_strings = FALSE;
			}
		} else if (strcasecmp(key[lp], "absence") == 0) {
			if (strcasecmp(value[lp], "yes") == 0){
				cfg->absence.mode = TRUE;
			} else {
				cfg->absence.mode = FALSE;
			}
		} else if (strcasecmp(key[lp], "store message") == 0) {
			if ((i = strtol(value[lp], &endp, 0)) != 0) cfg->store_message = i;
		} else if (strcasecmp(key[lp], "use userlist") == 0) {
			if (strcasecmp(value[lp], "yes") == 0){
				cfg->flush_userlist = TRUE;
			} else {
				cfg->flush_userlist = FALSE;
			}
		} else if (strcasecmp(key[lp], "type of userlist") == 0) {
			if (strcasecmp(value[lp], "tab") == 0){
				cfg->type_of_userlist = TAB_USERLIST;
				d_printf("Designate tab separate userlist\n");
			} else {
				cfg->type_of_userlist = NORMAL_USERLIST;
			}
		} else if (strcasecmp(key[lp], "use userlist log") == 0) {
			if (strcasecmp(value[lp], "yes") == 0){
				cfg->userlist_logging = TRUE;
			} else {
				cfg->userlist_logging = FALSE;
			}
		} else if (strcasecmp(key[lp], "no entry") == 0) {
			if (strcasecmp(value[lp], "yes") == 0){
				cfg->no_entry = TRUE;
			} else {
				cfg->no_entry = FALSE;
			}
		} else if (strcasecmp(key[lp], "hw kana") == 0) {
			if (strcasecmp(value[lp], "kill") == 0){
				cfg->hw_kana = 0;
			} else if (strcasecmp(value[lp], "fit") == 0){
				cfg->hw_kana = 1;
			} else if (strcasecmp(value[lp], "rescue") == 0){
				cfg->hw_kana = 2;
			} else if (strcasecmp(value[lp], "dark") == 0){
				cfg->hw_kana = 3;
			}
		} else if (strcasecmp(key[lp], "character code") == 0) {
			Xstrncpy(cfg->char_code, value[lp], NAMELEN);
		} else if (strcasecmp(key[lp], "flush timeleft") == 0) {
			if ((i = strtol(value[lp], &endp, 0)) != 0) cfg->flush_timeleft = i;
		} else if (strcasecmp(key[lp], "send readmsg on the receive") == 0) {
			if (strcasecmp(value[lp], "yes") == 0){
				cfg->send_readmsg_on_the_receive = TRUE;
			} else {
				cfg->send_readmsg_on_the_receive = FALSE;
			}
		}
	}
	free(key);
	free(value);

	return TRUE;
}


/*
 * üԤˤ
 */
void information_for_everybody(char* buf, int len, int command, NET_MNG* net,
							   CONFIG_MNG* cfg, USERLIST_MNG* ulm)
{
	int lp;
	long addr;
	USERLIST* ul;

	for (ul = ulm->first; ul; ul = ul->next){
		if (sender(buf, len, ul->addr, command, net, cfg, ulm)<0)
			fprintf(stderr, "Invalid addr [%s]\n", Xinet_ntoa(ul->addr));
	}

	for (lp=0; lp<cfg->broadcast.num; lp++){
		int ret;
		d_printf("%d:Information : %s\n", lp, cfg->broadcast.addr[lp]);
		addr = hosttoaddr(cfg->broadcast.addr[lp]);
        if ((ret = sender(buf, len, addr, command, net, cfg, ulm))<0)
			fprintf(stderr, "Can't reach Broadcast[%s]\n", Xinet_ntoa(addr));
#if(0)
        sender(buf, len, addr, command, net, cfg, ulm);
        sender(buf, len, addr, command, net, cfg, ulm);
#endif
    }
}

/* Sender */
int sender(unsigned char *buf, int len, long addr, int command,
		   NET_MNG* net, CONFIG_MNG* cfg, USERLIST_MNG* ulm)
{
	int n;
	return Tsender(NULL, &n, buf, len, addr, command|net->append.ret,
					   net, cfg, ulm);
}

/* åѥС */
int proxy_sender(unsigned char *buf, int len, char* dest, int command, 
		   NET_MNG* net, CONFIG_MNG* cfg, USERLIST_MNG* ulm)
{
	char prebuf[UDP_BUF];
	int send_len, addr, n, ret, lp;

	addr = hosttoaddr(cfg->server);
	send_len = sprintf(prebuf, "%d:%d:%s:", 
					   TIPMSG_CMD_VERSION, cfg->special_mode, dest);
	send_len += len;
	d_printf("Psender - addr(%s) : %s...\n", cfg->server, prebuf);
	for (lp=0; lp<5; lp++) {
		ret = Tsender(prebuf, &n, buf, len, addr, command, net, cfg, ulm);
		d_printf("Send #%d\n", n);
		if (receiveACK(net, cfg, n)){
			d_printf("Receive ACK\n");
			break;
		}
		sleep(2);
	};
	if (lp>=5){
		fprintf(stderr, "No receive ACK\n");
		return 0;
	}
	return ret;
}

/* Text convert Sender (return: Х)*/
int Tsender(unsigned char* prebuf, int* n, unsigned char* buf, 
			int len, long addr, int command, 
			NET_MNG* net, CONFIG_MNG* cfg, USERLIST_MNG* ulm)
{
	int sd = net->sd;
	char full_buf[UDP_BUF];
	static long packet_no = 0;
	struct sockaddr_in	saddr;
	int send_len, header_len;

	if (!prebuf) prebuf = "";

    if (!packet_no){
        packet_no = time(&packet_no) + ((long) getpid() << 16);
    } else {
        packet_no++;
    }
	*n = packet_no;

	memset(&saddr, 0, sizeof(saddr));
	saddr.sin_family		= AF_INET;
	saddr.sin_port			= htons(cfg->ipmsg_port);
	saddr.sin_addr.s_addr	= addr;

	/* Make Message */
	if (len > UDP_BUF-100){
		len = UDP_BUF-100;
	}
	
	sprintf(full_buf, "%s%d:%ld:%s:%s:%d:", prebuf,
			IPMSG_VERSION, packet_no, cfg->username, cfg->hostname, command);
	header_len = strlen(full_buf);
    if (buf){
		memcpy(full_buf + header_len, buf, len);
	}

	/* Send */
	if ((send_len = Xsendto(cfg, sd, full_buf, header_len + len, 0, (struct sockaddr *)&saddr, sizeof(saddr))) == -1){
		perror("sendto err");
	}
	return send_len;
}

/* Receive Message function */
int recver(NET_MNG* net, CONFIG_MNG* cfg, USERLIST_MNG* ulm, MSGPACKAGE_MNG* mpm)
{
	int ret = 1, len;
    int retval;
	char entry_buf[NAMELEN*2];

	/* ȥ꡼ */
	sprintf(entry_buf, "%s%c%s", cfg->nickname, '\0', cfg->groupname);
	len = strlen(cfg->nickname) + strlen(cfg->groupname) + 2;
	information_for_everybody(entry_buf, len, IPMSG_BR_ENTRY, net, cfg, ulm);
	ulm->flag_flush = FALSE;

	if (cfg->no_entry){
		/* ȥ */
		information_for_everybody(NULL, 0, IPMSG_BR_EXIT, net, cfg, ulm);
		sleep(1);
		information_for_everybody(NULL, 0, IPMSG_BR_EXIT, net, cfg, ulm);
	}


	while(!g_exit){
        /* ճ */
        retval = Xselect(net->sd, cfg->flush_timeleft);
        if (retval == -1){
			perror("select failure.");
            if (cfg->flush_userlist){
				flush_userlist(cfg, ulm);
			}
			ret = 0;
            goto ERR0;
        } else if (!retval){
            if (ulm->flag_flush && cfg->flush_userlist){
				/* USER LIST ν񤭤 */
				flush_userlist(cfg, ulm);
            }
            continue;
        }
		if (!do_receive(net, cfg, ulm, mpm)){
			d_printf("do_selected_process fail.\n");
		}
	}
  ERR0:
	return ret;
}

int do_receive(NET_MNG* net, CONFIG_MNG* cfg, USERLIST_MNG* ulm, MSGPACKAGE_MNG* mpm)
{
    USERLIST* ul;
	unsigned char recvbuf[UDP_BUF];
	int len, elen, serial_no;

	int sd = net->sd;
	int	size = sizeof(struct sockaddr_in);
	char buf[MAXBUFLEN];
	MSG msg;
	char entry_buf[NAMELEN*2];
	MSGPACKAGE* package = NULL;
	struct sockaddr_in addr;
	unsigned long addr_als;

	/* ǡ */
	if ((len = Xrecvfrom(cfg, sd, recvbuf, UDP_BUF-1, 0, (struct sockaddr *)&addr, &size)) == -1){
		perror("recvfrom failure.");
		goto ERR0;
	}
	recvbuf[len]='\0';
	addr_als = addr.sin_addr.s_addr;

	/* ǡå¤ΤŸ */
	memset(&msg, 0, sizeof(MSG));
	if (!decom_msg(&msg, recvbuf, len+1)){
		fprintf(stderr, "Can't recognized message.");
		goto EXIT0;
	}
	/* Proxy working */
	if (msg.cmd_ver){
		proxy_working(&msg, &addr, net, cfg, ulm, mpm);
		goto EXIT0;
	}

	/* ޥα */
	d_printf("Command 0x%x\n", msg.command);
	switch(GET_MODE(msg.command)){
	case IPMSG_BR_ENTRY:
		if (cfg->print_entry){
			if ((ul = construct_userlist_from_msg(&msg, &addr))){
				fprintf(stdout, "Entry: %s@%s%s%s[%s]\n", 
						ul->nickname[0] ? ul->nickname : ul->user,
						ul->groupname, ul->groupname[0] ? "/" : "", ul->host, 
						inet_ntoa(addr.sin_addr));
			} else {
				fprintf(stdout, "Exit :%s@%s[%s]\n", msg.msg_user, 
						msg.msg_host, inet_ntoa(addr.sin_addr));
			}
		}
		elen = sprintf(entry_buf, "%s%c%s", 
					   cfg->nickname, '\0', cfg->groupname);
		if (!cfg->no_entry && sender(entry_buf, elen, addr_als, 
									 IPMSG_ANSENTRY, net, cfg, ulm) == -1){
			d_printf("ANSENTRY ERR\n");
			goto ERR0;
		}
		/* ̤ȴ */
	case IPMSG_ANSENTRY:
		if (!(ul = construct_userlist_from_msg(&msg, &addr))){
			goto ERR0;
		}
		append_userlist(ulm, ul);
		ulm->flag_flush = TRUE;
		break;
	case IPMSG_BR_ABSENCE:
		d_printf("Get IPMSG_BR_ABSENCE\n");
		if (!(ul = construct_userlist_from_msg(&msg, &addr))){
			goto ERR0;
		}
		append_userlist(ulm, ul);
		ulm->flag_flush = TRUE;
		break;
	case IPMSG_BR_EXIT:
		if (cfg->print_entry){
			if ((ul = construct_userlist_from_msg(&msg, &addr))){
				fprintf(stdout, "Exit : %s@%s%s%s[%s]\n", 
						ul->nickname[0] ? ul->nickname : ul->user,
						ul->groupname, ul->groupname[0] ? "/" : "", ul->host, 
						inet_ntoa(addr.sin_addr));
			} else {
				fprintf(stdout, "Exit :%s@%s[%s]\n", msg.msg_user, 
						msg.msg_host, inet_ntoa(addr.sin_addr));
			}
		}
		delete_userlist_by_addr(ulm, addr.sin_addr.s_addr);
		ulm->flag_flush = TRUE;
		break;
	case IPMSG_RECVMSG:
#if defined(ENDMARK)
		if (cfg->live) fprintf(stdout, RECVMSG_PRT "\r", msg.msg_user, msg.msg_host);
#else
		if (cfg->live) fprintf(stdout, RECVMSG_PRT, msg.msg_user, msg.msg_host);
#endif
		break;
	case IPMSG_READMSG:
		if (msg.command & IPMSG_READCHECKOPT){
			d_printf("Has READCHECKOPT\n");
			sprintf(buf, "%d", msg.packet_no);
			sender(buf, strlen(buf)+1, addr_als, IPMSG_ANSREADMSG,
				   net, cfg, ulm);
		}
#if defined(ENDMARK)
		if (cfg->live) fprintf(stdout, READMSG_PRT "\r", msg.msg_user, msg.msg_host);
#else
		if (cfg->live) fprintf(stdout, READMSG_PRT, msg.msg_user, msg.msg_host);
#endif
		break;
	case IPMSG_GETINFO:
		sender(cfg->vermsg, strlen(cfg->vermsg)+1,addr_als, 
			   IPMSG_AUTORETOPT|IPMSG_SENDINFO, net, cfg, ulm);
		break;
	case IPMSG_GETABSENCEINFO:
		if (net->append.ret & IPMSG_ABSENCEOPT){
			send_file(addr_als, cfg->absence.file,
					  IPMSG_AUTORETOPT|IPMSG_SENDABSENCEINFO, net, cfg, ulm);
		} else {
			sender(ABSENCE_MESSAGE, strlen(ABSENCE_MESSAGE)+1, 
				   addr_als, IPMSG_AUTORETOPT|IPMSG_SENDABSENCEINFO, 
				   net, cfg, ulm);
		}
		break;
	case IPMSG_SENDMSG:
		switch (check_message(&msg, &addr, net, cfg, ulm)){
		case MSG_NORMAL:
			d_printf("RECV NORMAL\n");
			serial_no = store_message(&msg, &addr, cfg, ulm);
			/* (ؼƤ) å */
			if ((msg.command & IPMSG_SECRETOPT)){
				if (!add_for_readmsg_mng(serial_no, msg.packet_no, addr_als)){
					break;
				}
				if (cfg->send_readmsg_on_the_receive){
					request_for_readmsg_mng(0, net, cfg, ulm);
				}
			}
			
			/* å¸ */
			if (!(ul = search_userlist_by_addr(ulm, addr_als))){
				sender(NULL, 0, addr_als, IPMSG_BR_ENTRY, net, cfg, ulm);
			} else {
				if(!(package = construct_msgpackage(ul, &msg))){
					d_printf("Can't create messge package buffer.\n");
					goto EXIT0;
				}
				if (!append_msgpackage(mpm, package)){
					d_printf("Append Msg Package False.\n");
				}
			}
			break;
		case MSG_QUIT: /* λ */
			store_message(&msg, &addr, cfg, ulm);
			g_exit = 1;
			goto ERR0;
		case MSG_UPDATE: /*  */
			d_printf("Check message UPDATE return.\n");
			ulm->flag_flush = TRUE;
			break;
		default:
			break;
		}
		break;
	default:
		d_printf("Recive unknow command: 0x%08x\n", msg.command);
	}

  EXIT0:
	fflush(stdout);
	return len;

  ERR0:
	fflush(stdout);
	return 0;
}

/* ե */
int send_file(long addr, char* fname, int command, 
			  NET_MNG* net, CONFIG_MNG* cfg, USERLIST_MNG* ulm)
{
	struct stat sbuf;
	int len;
	char buf[UDP_BUF];
	int fd;

	d_printf("START send_file(%s)\n", fname);
	if (fname[0] == '\0') return 0;
	if (stat(fname, &sbuf) != 0){
		fprintf(stderr, "Can't get file status(%s) : %s\n", 
				fname, ERRMSG);
		return 0;
	}
	if (!sbuf.st_size){
		fprintf(stderr, "File(%s) size is Zero.\n", fname);
		return 0;
	}
	if ((fd = open(fname, O_RDONLY)) <0){
		fprintf(stderr, "Can't open file(%s) : %s\n", fname, ERRMSG);
		return 0;
	}
	len = (sbuf.st_size < UDP_BUF-1) ? sbuf.st_size : UDP_BUF -1;
	if (read(fd, buf, len)<0){
		fprintf(stderr, "Can't open file(%s) : %s\n", fname, ERRMSG);
		return 0;
	}
	buf[len]='\0';
	return sender(buf, strlen(buf)+1, addr, command, net, cfg, ulm);
}

int set_signal(void (*handler)(int))
{
	struct sigaction act;
	int ret;

	act.sa_handler = handler;
	sigemptyset(&act.sa_mask);
	act.sa_flags = SA_NOCLDSTOP;

	ret = sigaction(SIGALRM, &act, 0);
	ret |= sigaction(SIGHUP, &act, 0);
	ret |= sigaction(SIGINT, &act, 0);
	ret |= sigaction(SIGPIPE, &act, 0);
	ret |= sigaction(SIGTERM, &act, 0);
	ret |= sigaction(SIGQUIT, &act, 0);
	ret |= sigaction(SIGCHLD, &act, 0);
	if (ret) perror("setaction failer in  basic sigaction");

#if(0)	
	ret = sigaction(SIGFPE, &act, 0);
	ret |= sigaction(SIGILL, &act, 0);
	ret |= sigaction(SIGSEGV, &act, 0);
	if (ret) perror("setaction failer in  advanced sigaction");
#endif

	d_printf("Set signal catch\n");
	return ret;
}

void interrupt_exit(int num)
{
	switch(num){
	case SIGPIPE:
		break;
	default:
		d_printf("Catch the terminate signal(%d)\n", num);
		g_exit = 1;
	}
}

/* Ȥɽ */
void print_usage()
{
    printf("tipmsg ver %s - Text IP Messenger\n", TIPMSG_VERSION);
	printf("A ... Reverse absence mode config.\n");
	printf("C ... Designate config file.\n");
	printf("D ... Translate daemon mode.\n");
	printf("E ... Designate EUC-JP KANJI code for Input case.\n");
	printf("H ... Print this message.\n");
	printf("J ... Designate JIS KANJI code for Input case.\n");
	printf("K ... Reverse a sealed mode.\n");
	printf("L ... Reverse Live mode.\n");
	printf("N ... Reverse No entry mode.\n");
	printf("O ... Reverse Open otify mode.\n");
	printf("P ... Designate IPMSG port.\n");
	printf("Q ... Reverse printable Entry, Exit.\n");
	printf("S ... Designate SJIS KANJI code for Input case.\n");
	printf("T ... Desigante type of userlist.\n");
	printf("U ... Output userlist\n");
	printf("X ... Reverse a sealed message with lock mode.\n");
	printf("e ... Designate editor.\n");
	printf("f ... Desiganet send message file.\n");
	printf("o ... Sending open notify.\n");
	printf("r ... Reply mode.\n");
	printf("s ... Sender mode.\n");
	printf("t ... Terminate tipmsg.\n");
	printf("u ... Sending designated user\n");
	printf("h,k,p,x ... Same a capital letter.\n");
}

/* åνå */
int check_message(MSG* msg, struct sockaddr_in* psaddr, 
				  NET_MNG* net, CONFIG_MNG* cfg, USERLIST_MNG* ulm)
{
	char entry_buf[NAMELEN*2];
	int len;
	char buf[UDP_BUF];

    /* å */
    if ((msg->command & IPMSG_SENDCHECKOPT) &&
		!(msg->command & (IPMSG_BROADCASTOPT|IPMSG_AUTORETOPT))){
        sprintf(buf, "%d", msg->packet_no);
        if (!sender(buf, strlen(buf)+1, psaddr->sin_addr.s_addr, IPMSG_RECVMSG,
					net, cfg, ulm)){
            return 0;
        }
    }

	if (cfg->enable_special_strings){
		/* Ƭʸˤưѹ */
		if (strncmp(msg->extend, "quit", 4) == 0){
			d_printf("QUIT REQUIRED!\n");
			msg->extend[0]='\0';
			return MSG_QUIT;
		} else if (strncmp(msg->extend, "absence", 7) == 0){
			d_printf("%sABSENCE REQUIRED!\n", 
					 (net->append.ret & IPMSG_ABSENCEOPT) ? "UN" : "");
			msg->extend[0]='\0';
			/* Ժưȿž*/
			if (net->append.ret & IPMSG_ABSENCEOPT){
				net->append.ret &= ~IPMSG_ABSENCEOPT;
			} else {
				net->append.ret |= IPMSG_ABSENCEOPT;
			}
			sprintf(entry_buf, "%s%c%s", cfg->nickname, '\0', cfg->groupname);
			len = strlen(cfg->nickname) + strlen(cfg->groupname) + 2;
			information_for_everybody(entry_buf, len, IPMSG_BR_ABSENCE, 
									  net, cfg, ulm);
			return MSG_ABSENCE;
		} else if (strncmp(msg->extend, "update", 6) == 0){
			d_printf("UPDATE REQUIRED!\n");
			msg->extend[0]='\0';
			destroy_userlist(ulm);
			load_config(cfg->filename, cfg);
		
			sprintf(entry_buf, "%s%c%s", cfg->nickname, '\0', cfg->groupname);
			len = strlen(cfg->nickname) + strlen(cfg->groupname) + 2;
			information_for_everybody(entry_buf, len, IPMSG_BR_ENTRY, 
									  net, cfg, ulm);
			return MSG_UPDATE;
		}
	}

	/* ưåˤϤʹߤαϤʤ */
	if (msg->command & IPMSG_AUTORETOPT){
		d_printf("It's IPMSG_AUTORETOPT.\n");
		return MSG_NORMAL;
	}
	/* Ժ߻ */
	if (net->append.ret & IPMSG_ABSENCEOPT){
		d_printf("cfg->absence.file[%s]\n", cfg->absence.file);
		send_file(psaddr->sin_addr.s_addr, cfg->absence.file, 
				  IPMSG_AUTORETOPT|IPMSG_SENDMSG, net, cfg, ulm);
	}
	return MSG_NORMAL;
}

int send_message(NET_MNG* net, CONFIG_MNG* cfg, USERLIST_MNG* ulm, char* send_list[])
{
	int lp, len, pos = 0;
	unsigned char buf[UDP_BUF]="", msg[0x100]="";
	unsigned char user[NAMELEN]="";

	/* ץ饤⡼ɤǤϥեƤ򥳥ԡ */
	if (cfg->special_mode & SPECIAL_OPT_REPLY){
		d_printf("REPLY!!\n");
		pos = create_replybuf(buf, UDP_BUF, user, cfg);
	}

	/* ǥꤵƤХǥѤå */
	/* ̤ɸϤǡȤäåȤ */
	if (cfg->editor[0]){
		if (!(pos = create_sendbuf_with_editor(buf, pos, UDP_BUF, cfg))){
			return 0;
		}
	} else {
		while ((len = read(STDIN_FILENO, buf + pos, UDP_BUF - pos))) {
			if ((pos += len) >= UDP_BUF) break;
		}
	}

	/* ץ饤Ԥʤ */
	while(user[0]){
		int mode = cfg->special_mode;
		/* ɸϤߥʥʤ顢ǧԤʤ */
		sprintf(msg, "Send reply message for %s [Y/N] : ", user);
		if (!confirm(msg, 'Y')){
			fprintf(stdout, "Cancel!\n");
			break;
		}
		d_printf("SEND MESSAGE[%s] : %s\n", user, buf);
		cfg->special_mode |= SPECIAL_OPT_USE_USERNAME;
		proxy_sender(buf, pos, user, 
					 IPMSG_SENDMSG|cfg->append.send, net, cfg, ulm);
		cfg->special_mode = mode;
		break;
	}

	/* Ԥʤ */
	for (lp=0; send_list[lp]; lp++){
		/* ɸϤߥʥʤ顢ǧԤʤ */
		sprintf(msg, "Send message for %s [Y/N] : ", send_list[lp]);
		if (!confirm(msg, 'Y')){
			fprintf(stdout, "Cancel!\n");
			continue;
		}
		d_printf("SEND MESSAGE[%s] : %s\n", send_list[lp], buf);
		proxy_sender(buf, pos, send_list[lp], 
					 IPMSG_SENDMSG|cfg->append.send, net, cfg, ulm);
	}
	return 1;
}

/*
    2ͤϤ
    msg ... ɽʸ
    yes ... ֤1ʸ

	ϤʸѴӤΤ yes ˤɬʸꤹ
    ɸϤüǤʤϾ˿
*/
int confirm(char* msg, char yes){
	unsigned char ans[3] = "";
	if (!isatty(STDIN_FILENO)) return 1;

	fprintf(stderr, "%s", msg);
	while(fgets(ans, 3, stdin) != NULL && !ans[0]);
	d_printf("[%c] ANSWER : %s", yes, ans);
	if (toupper(ans[0]) == yes) return 1;
	d_printf("[%c] != [%c] \n", toupper(ans[0]), yes);
	return 0;
}

/* 
   ǥȤäХåե롣
   ｪλϿ 
 */
int create_sendbuf_with_editor(char* buf, int pos, int size, CONFIG_MNG* cfg)
{
	pid_t pid;
	int status, fd = -1, len;
	char* send_file = cfg->send_file;
	char* editor = cfg->editor;

	if (!isatty(STDIN_FILENO)){
		/* ɸϤߥʥǤʤϡɸϤΥǡ
           ե˽񤭽Ф */
		while ((len = read(STDIN_FILENO, buf + pos, size - pos))) {
			if (len < 0) fprintf(stderr, "Can't read file(%s) : %s\n", send_file, ERRMSG);
			if ((pos += len) >= size) break;
		}
	}

	/* Хåե˥ǡ¸ߤȤϥե˽񤭽Ф */
	if (buf[0]){
		if ((fd = open(send_file, O_RDWR|O_CREAT|O_APPEND, 0600)) == -1){
			fprintf(stderr, "Can't open file(%s) : %s\n", send_file, ERRMSG);
			return 0;
		}

		if (write(fd, buf, pos)<0){
			fprintf(stderr, "Can't write file(%s) : %s\n", send_file, ERRMSG);
		}
		close(fd);
		pos = 0;
	}

	/* ץƥǥư */
	if ((pid = fork()) == 0) {
		char command[PATH_MAX];
		sprintf(command, "%s %s", editor, send_file);
		execlp("/bin/sh", "sh", "-c", command, NULL);
		/* execlp Фʹߤϼ¹Ԥʤ */
		perror("Can't exec editor");
		return 0;
	} else if (pid == -1) {
		perror("Can't create process");
		return 0;
	}
	if (wait(&status)<=0){
		perror("Error on wait for editor");
		return 0;
	}
		
	/* 񤭹ޤ줿ե뤫Ƥɤ߹ */
	if ((fd = open(send_file, O_RDONLY)) == -1){
		fprintf(stderr, "Can't open file(%s) : %s\n", send_file, ERRMSG);
		return 0;
	}
	while ((len = read(fd, buf + pos, size - pos))) {
		if (len < 0) fprintf(stderr, "Can't read file(%s) : %s\n", send_file, ERRMSG);
		if ((pos += len) >= size) break;
	}

	/* -f ե饰ꤵƤʤѤե */
	if (!cfg->send_file_keep_it) unlink(send_file);
	d_printf("Messege length is %d.\n", pos);
	close(fd);

	return pos;
}

/* ץ饤ѥǡκ */
int create_replybuf(char* buf, int size, char* user, CONFIG_MNG* cfg)
{
	char replyfile[PATH_MAX];
	char tmp[0x100] = "";
	FILE* fp;
	int lp, pos = 0, prefix_len;
	char *head, *tail;

	prefix_len = strlen(cfg->reply_prefix);

	/* եΥץ */
	if (cfg->reply){
		sprintf(replyfile, "%s/%0" SAVE_FILE_NUM_MAX "d", 
				cfg->paper_log_dir, cfg->reply);
	} else {
		sprintf(replyfile, "%s/%d", cfg->paper_log_dir, cfg->reply);
	}
	d_printf("Using file : %s\n", replyfile);
	if ((fp = fopen(replyfile, "r")) == NULL){
		fprintf(stderr, "Can't open file(%s) : %s\n", replyfile, strerror(errno));
		return 0;
	}
	d_printf("Length : %d\n", pos);

	/* ǡμ */
	for(lp = 0; pos < size && fgets(tmp, 0x100, fp); lp++){
		if (lp < cfg->reply_ignore){
			/* 桼θ */
			if ((head = strchr(tmp, '['))){
				head++;
				if ((tail = strchr(head, ']'))){
					memcpy(user, head, tail - head);
					user[tail - head] = '\0';
				}
			}
			continue;
		}
		if (cfg->reply_prefix[0]) {
			strcpy(buf+pos, cfg->reply_prefix);
			pos += prefix_len;
		}
		strcpy(buf + pos, tmp);
		pos += strlen(tmp);
	}
	d_printf("Length : %d\n%s\n", pos, strerror(errno));
	fclose(fp);
	return pos;
}

int proxy_working(MSG* msg, 	struct sockaddr_in* addr, 
				 NET_MNG* net, CONFIG_MNG* cfg, USERLIST_MNG* ulm, 
				 MSGPACKAGE_MNG* mpm)
{
	int dest;
	d_printf("Found cmd_ver[0x%x].\n", msg->cmd_ver);
	sendACK(net, cfg, addr, msg->packet_no);
	if (msg->cmd & SPECIAL_SEND_MODE){
		if (msg->cmd & SPECIAL_OPT_READMSG){
			/* Τ */
			d_printf("Receive SPECIAL_OPT_READMSG->\n");
			if ((dest = strtol(msg->data, NULL, 0))<0){
				request_all_for_readmsg_mng(net, cfg, ulm);
			} else {
				request_for_readmsg_mng(dest, net, cfg, ulm);
			}
			return 1;
		}

		/* å */
		if (!(dest = (msg->cmd & SPECIAL_OPT_USE_USERNAME) ? 
			  iusertoaddr(msg->data, ulm) : ihosttoaddr(msg->data, ulm))){
			d_printf("Not found valid tipmsg cmd.\n");
			return 1;
		}				

		d_printf("PROXY To %s : %s\n", msg->data, msg->extend);
		sender(msg->extend, strlen(msg->extend)+1, dest, 
			   msg->command, net, cfg, ulm);
		d_printf("Message from %s:%d\n", 
				 inet_ntoa(addr->sin_addr), addr->sin_port);
		return 1;
	}
	return 1;
}
