/* $Id: tipmsg.h,v 1.9 2005/01/28 04:57:15 kouno Exp $ */

#define TIPMSG_VERSION "0.32"
#define ACK "ACK"

#define TIPMSG_CMD_VERSION 0x1000
#define UDP_BUF 8192

/* PROXY COMMAND */
#define PROXY_SENDMSG 0x00000020UL

/* Special mode */
#define SPECIAL_SEND_MODE 0x00000001UL
#define SPECIAL_TERM_MODE 0x00000002UL

/* Special mode */
#define SPECIAL_OPT_USE_USERNAME 0x00010000UL
#define SPECIAL_OPT_REPLY        0x00020000UL
#define SPECIAL_OPT_READMSG      0x00040000UL

/* Other */
#if defined(TIPMSGDIR)
#define TIPMSGDIR_PATH TIPMSGDIR
#else
#define TIPMSGDIR_PATH "tipmsg"
#endif

#define CONFIG_FILE "tipmsg.conf"

#define ENV_HOME "HOME"
#define ENV_OSTYPE "OSTYPE"
#define ENV_HOSTTYPE "HOSTTYPE"

#define DEFAULT_USERLIST "userlist"
#define DEFAULT_USERLIST_LOG "userlist.log"
#define DEFAULT_PAPER_DIR "store"
#define DEFAULT_SCROLL_FILE  "tipmsg.log"
#define DEFAULT_ABSENCEFILE "absence.txt"
#define DEFAULT_PIDFILE "tipmsg.pid"
#define DEFAULT_STORE_MESSAGE (1000)
#define ABSENCE_MESSAGE "I'm exist"
#define DEFAULT_SENDFILE "sendfile"
#define DEFAULT_REPLY_PREFIX "> "
#define ABSENCE_CHAR 'A'
#define UNABSENCE_CHAR ' '

#define RECVMSG_PRT "Receive check message from %s@%s\n"
#define READMSG_PRT "Open check message from %s@%s\n"

#define SAVE_FILE_NUM_MAX "4"
#define LATEST_MSG "0"

#define BROADCAST "DEFAULT"
#define MAXBUFLEN 0x2ff
#define BROADCAST_MAX 0x100
#define NAMELEN 0x100
#define MAX_RETRY 1
#define RETRY_WAIT 2
#define CODE_SJIS "sjis"
#define CODE_EUCJP "euc-jp"
#define CODE_JIS "jis"

#define ASCII 0
#define JAPANESE 1

#define SD_MAX 64
/* Client/Server Protocol */
#define CSP_NOTICE "NOTICE"

#if !defined(FALSE)
#define FALSE 0
#endif

#if defined(TRUE)
#undef TRUE
#endif
#define TRUE (!FALSE)

#define OFF 0
#define ON (!OFF)

#define ERRMSG strerror(errno)

enum SP_MSGNO {MSG_NORMAL = 0, MSG_QUIT=1, MSG_ABSENCE, MSG_UPDATE, MSG_LAST};

typedef struct {
	int   cmd_ver;
	int   cmd;
	char  data[NAMELEN];
	int serial_no;
/* Official IP Messenger Protocol */
    int   format_ver;
    int   packet_no;
    char  msg_user[NAMELEN];
    char  msg_host[NAMELEN];
    int   command;
	int   len;
    char* group;
    char  extend[UDP_BUF];
} MSG;

typedef struct READMSG_PKG_ {
	struct READMSG_PKG_* prev;
	struct READMSG_PKG_* next;

	long serial_no;
	long packet_no;
	unsigned long addr;
} READMSG_PKG;

typedef struct {
	READMSG_PKG* first;
	READMSG_PKG* last;
} READMSG_MNG;

typedef struct USERLIST_TMP {
    struct USERLIST_TMP* next;
    struct USERLIST_TMP* prev;
/*	struct sockaddr_in	saddr; */
	int port;
	unsigned int addr;

    char user[NAMELEN];
    char host[NAMELEN];
	char nickname[NAMELEN];
	char groupname[NAMELEN];
	char absence;
} USERLIST;

typedef struct {
    USERLIST* first;
    USERLIST* last;

	int flag_flush;
} USERLIST_MNG;

typedef struct MSGPACKAGE_ {
	struct MSGPACKAGE_* prev;
	struct MSGPACKAGE_* next;

	int serial_no;
	int packet_no;

	time_t received_time;
	int len;

    char* user;
    char* host;
	char* nickname;
	char* groupname;
	char* content;
} MSGPACKAGE;

typedef struct {
	MSGPACKAGE* first;
	MSGPACKAGE* last;
	MSGPACKAGE* current;
	int store_message;
	int max_store_message;
} MSGPACKAGE_MNG;

typedef struct {
	int num;
	char* addr[BROADCAST_MAX];
} BROADCAST_MNG;

typedef struct {
	int mode;
	char file[PATH_MAX];
} ABSENCE_MNG;

typedef struct {
	int send;
	int ret;
} APPEND_T;

typedef struct {
	APPEND_T append;
	int live;
	int daemon;
	int flush_userlist;
	int type_of_userlist;
	int no_entry;
	int ipmsg_port;
	int print_entry;
	int special_mode;
	int store_message;
	int hw_kana;
	int flush_timeleft;
	int reply;
	int reply_ignore;
	int send_file_keep_it;
	int enable_special_strings;
	int send_readmsg_on_the_receive;
	int readmsg_no;
	int userlist_logging;

	char reply_prefix[NAMELEN];
	char send_file[PATH_MAX];
	char editor[PATH_MAX];
	char server[PATH_MAX];
	char filename[PATH_MAX];
	char char_code[NAMELEN];
	char char_code_in[NAMELEN];
	char paper_log_dir[PATH_MAX];
	char scroll_log_file[PATH_MAX];
	char userlist_file[PATH_MAX];
	char userlist_logfile[PATH_MAX];
	char pid_file[PATH_MAX];
	char nickname[NAMELEN];
	char groupname[NAMELEN];
	char vermsg[NAMELEN];
	char tipmsgdir[PATH_MAX];
	char hostname[NAMELEN];
	char username[NAMELEN];
	ABSENCE_MNG absence;
	BROADCAST_MNG broadcast;
} CONFIG_MNG;

enum TYPE_OF_USERLIST{NORMAL_USERLIST = 0, TAB_USERLIST = 1, NUM_OF_USERLIST};

typedef struct {
	int sd;
	APPEND_T append;
} NET_MNG;

/* ؿ */
int sender(unsigned char *buf, int len, long addr, int command, 
		   NET_MNG* net, CONFIG_MNG* cfg, USERLIST_MNG* ulm);
int recver(NET_MNG* net, CONFIG_MNG* cfg, 
		   USERLIST_MNG* ulm, MSGPACKAGE_MNG* mpm);
int do_receive(NET_MNG* net, CONFIG_MNG* cfg, 
				 USERLIST_MNG* ulm, MSGPACKAGE_MNG* mpm);
int send_file(long addr, char* fname, int command, 
			  NET_MNG* net, CONFIG_MNG* cfg, USERLIST_MNG* ulm);
void information_for_everybody(char* buf, int len, int command,
							   NET_MNG* net,
							   CONFIG_MNG* config_mng, 
							   USERLIST_MNG* userlist_mng);
int proxy_sender(unsigned char *buf, int len, char* dest, int command, 
				 NET_MNG* net, CONFIG_MNG* cfg, USERLIST_MNG* ulm);
int send_message(NET_MNG* net, CONFIG_MNG* cfg, USERLIST_MNG* ulm, char* send_list[]);
int Tsender(unsigned char* prebuf, int* n, 
			unsigned char* buf, int len, long addr, 
			int command, NET_MNG* net, CONFIG_MNG* cfg, USERLIST_MNG* ulm);

long hosttoaddr(char *target);
long ihosttoaddr(char* target, USERLIST_MNG* ulm);
long iusertoaddr(char* target, USERLIST_MNG* ulm);

/* åؿ*/
int decom_msg(MSG *msg, const char *buf, int len);
void print_usage(void);
int check_message(MSG* msg, struct sockaddr_in* psaddr, NET_MNG* net, CONFIG_MNG* cfg, USERLIST_MNG* ulm);
int store_message(MSG *msg, struct sockaddr_in* psaddr, CONFIG_MNG* cfg, USERLIST_MNG* ulm);
int print_message(FILE* fp, MSG* msg, struct sockaddr_in* psaddr, USERLIST_MNG* ulm);

/* ɤ߹ߴؿ */
int configuration(int argc, char** argv, CONFIG_MNG* cfg);
int proceed_config(CONFIG_MNG* cfg);
int analyze_option(int argc, char** argv, CONFIG_MNG* cfg);
int load_config(char* fname, CONFIG_MNG* cfg);
int default_config(CONFIG_MNG* cfg);

/* ե ʸؿ */
char* terminate_line(char* buf);
char* extract_value(char* buf);
char* extract_section(char* buf);

/* 桼ꥹؿ() */
USERLIST* construct_userlist_from_msg(MSG* msg, struct sockaddr_in* saddr);
int append_userlist(USERLIST_MNG* ulm, USERLIST* ul);
int delete_userlist_by_addr(USERLIST_MNG* mng, long addr);
void destroy_userlist(USERLIST_MNG* ulm);
#define search_userlist(mng, list) search_userlist_by_addr(mng, list->saddr.sin_addr.s_addr)
USERLIST* search_userlist_by_addr(USERLIST_MNG* mng, long addr);
USERLIST* search_userlist_by_host(USERLIST_MNG* mng, char* host);
USERLIST* search_userlist_by_user(USERLIST_MNG* mng, char* user);
int is_in_userlist(USERLIST_MNG* mng, USERLIST* ul);
int flush_userlist(CONFIG_MNG* cfg, USERLIST_MNG* ulm);
/* 桼ꥹؿ() */
int unlink_userlist(USERLIST_MNG* mng, USERLIST* ul);
int insert_userlist(USERLIST_MNG* mng, USERLIST* ul);
int swap_userlist(USERLIST_MNG* mng, USERLIST* s1, USERLIST* s2);

/* åѥåؿ */
MSGPACKAGE* construct_msgpackage(USERLIST* ul, const MSG* msg);
void destruct_msgpackage(MSGPACKAGE* package);

int append_msgpackage(MSGPACKAGE_MNG* mng, MSGPACKAGE* package);
MSGPACKAGE* search_msgpackage_by_serial_no(MSGPACKAGE_MNG* mng, int number);
int delete_msgpackage_by_serial_no(MSGPACKAGE_MNG* mng, int number);
MSGPACKAGE* setforward_msgpackage_current(MSGPACKAGE_MNG* mng);
MSGPACKAGE* setbackward_msgpackage_current(MSGPACKAGE_MNG* mng);
MSGPACKAGE* set_msgpackage_current(MSGPACKAGE_MNG* mng, int number);
int serialize_msgpackage(char* buf, int size, MSGPACKAGE* msg);

/* ¾*/
void interrupt_exit(int num);
void dummy_function(char *dummy,...);
void became_a_daemon(char* argv[]);
int set_signal(void (*handler)(int));
int Xstrncpy(char* dest, const char* src, int len);
int Xsendto(CONFIG_MNG* cfg, int s, const void *msg, size_t len, int flags,	
			const struct sockaddr *to, int tolen);
int Xrecvfrom(CONFIG_MNG* cfg, int s, void  *buf,  size_t  len,  int  flags, struct sockaddr *from, int *fromlen);
pid_t read_pid_file(const char* file);
int create_pid_file(const char* file);
int delete_msgpackage(MSGPACKAGE_MNG* mng, MSGPACKAGE* target);
int take_first_userlist(USERLIST_MNG* mng, USERLIST* ul);
int create_sendbuf_with_editor(char* buf, int pos, int size, CONFIG_MNG* cfg);
int create_replybuf(char* buf, int size, char* user, CONFIG_MNG* cfg);
char* transfer_kanji_code(CONFIG_MNG* cfg, unsigned char* buf, int* len, int size, char* in, char* out);
void code_transferES(unsigned char* first, unsigned char* second);
void code_transferSE(unsigned char* first, unsigned char* second);
void SJIS_htof(unsigned char* first, unsigned char* second);
char* Xinet_ntoa(unsigned long addr);
int Xselect(int fd, int timeout);
int sendACK(NET_MNG* net, CONFIG_MNG* cfg, struct sockaddr_in* addr, int num);
int receiveACK(NET_MNG* net, CONFIG_MNG* cfg, int num);
int confirm(char* msg, char yes);

/* READMSG_MNG* query_for_readmsg_mng(void); */
int add_for_readmsg_mng(long serial_no, long packet_no, long addr);
int request_for_readmsg_mng(int serial_no, NET_MNG* net, CONFIG_MNG* cfg, USERLIST_MNG* ulm);
int request_all_for_readmsg_mng(NET_MNG* net, CONFIG_MNG* cfg, USERLIST_MNG* ulm);
int proxy_working(MSG* msg, 	struct sockaddr_in* addr, NET_MNG* net, CONFIG_MNG* cfg, USERLIST_MNG* ulm, MSGPACKAGE_MNG* mpm);
int create_filename_for_anyport(char* buf, char* def, CONFIG_MNG* cfg);
